<?php
/**
 * InlineResponse20079ContentAllOfAllOf
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20079ContentAllOfAllOf Class Doc Comment
 *
 * @category Class
 * @description Describes a pc or server
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20079ContentAllOfAllOf implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_79_content_allOf_allOf';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'inventoryNumber' => 'string',
        'active' => 'bool',
        'companyId' => 'int',
        'name' => 'string',
        'serviceTechnicianId' => 'int',
        'employeeId' => 'int',
        'date' => 'int',
        'location' => 'string',
        'manufacturerId' => 'int',
        'model' => 'string',
        'serialNumber' => 'string',
        'osId' => 'int',
        'software' => 'string',
        'remark' => 'string',
        'showRemark' => 'bool',
        'mainboardManufacturerId' => 'int',
        'mainboardManufacturerRevision' => 'string',
        'mainboardSerialNumber' => 'string',
        'bios' => 'string',
        'biosRelease' => 'string',
        'cpuManufacturerId' => 'int',
        'cpuTypeId' => 'int',
        'cpuFrequency' => 'int',
        'cpuNumber' => 'int',
        'mouseSerialNumber' => 'string',
        'keyboadSerialNumber' => 'string',
        'server' => 'bool',
        'internalRemark' => 'string',
        'billingNumber' => 'string',
        'articleNumber' => 'string',
        'manufacturerNumber' => 'string',
        'hostId' => 'int',
        'purchasePrice' => 'float',
        'sellingPrice' => 'float',
        'ownageType' => 'string',
        'storageId' => 'int',
        'teamviewerId' => 'string',
        'teamviewerPassword' => 'string',
        'anydeskId' => 'string',
        'anydeskPassword' => 'string',
        'reservedRam' => 'float',
        'reservedHardDisk' => 'float',
        'reservedCpu' => 'float',
        'description' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'inventoryNumber' => null,
        'active' => null,
        'companyId' => null,
        'name' => null,
        'serviceTechnicianId' => null,
        'employeeId' => null,
        'date' => 'timestamp',
        'location' => null,
        'manufacturerId' => null,
        'model' => null,
        'serialNumber' => null,
        'osId' => null,
        'software' => null,
        'remark' => null,
        'showRemark' => null,
        'mainboardManufacturerId' => null,
        'mainboardManufacturerRevision' => null,
        'mainboardSerialNumber' => null,
        'bios' => null,
        'biosRelease' => null,
        'cpuManufacturerId' => null,
        'cpuTypeId' => null,
        'cpuFrequency' => null,
        'cpuNumber' => null,
        'mouseSerialNumber' => null,
        'keyboadSerialNumber' => null,
        'server' => null,
        'internalRemark' => null,
        'billingNumber' => null,
        'articleNumber' => null,
        'manufacturerNumber' => null,
        'hostId' => null,
        'purchasePrice' => null,
        'sellingPrice' => null,
        'ownageType' => null,
        'storageId' => null,
        'teamviewerId' => null,
        'teamviewerPassword' => null,
        'anydeskId' => null,
        'anydeskPassword' => null,
        'reservedRam' => null,
        'reservedHardDisk' => null,
        'reservedCpu' => null,
        'description' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'inventoryNumber' => 'inventoryNumber',
        'active' => 'active',
        'companyId' => 'companyId',
        'name' => 'name',
        'serviceTechnicianId' => 'serviceTechnicianId',
        'employeeId' => 'employeeId',
        'date' => 'date',
        'location' => 'location',
        'manufacturerId' => 'manufacturerId',
        'model' => 'model',
        'serialNumber' => 'serialNumber',
        'osId' => 'osId',
        'software' => 'software',
        'remark' => 'remark',
        'showRemark' => 'showRemark',
        'mainboardManufacturerId' => 'mainboardManufacturerId',
        'mainboardManufacturerRevision' => 'mainboardManufacturerRevision',
        'mainboardSerialNumber' => 'mainboardSerialNumber',
        'bios' => 'bios',
        'biosRelease' => 'biosRelease',
        'cpuManufacturerId' => 'cpuManufacturerId',
        'cpuTypeId' => 'cpuTypeId',
        'cpuFrequency' => 'cpuFrequency',
        'cpuNumber' => 'cpuNumber',
        'mouseSerialNumber' => 'mouseSerialNumber',
        'keyboadSerialNumber' => 'keyboadSerialNumber',
        'server' => 'server',
        'internalRemark' => 'internalRemark',
        'billingNumber' => 'billingNumber',
        'articleNumber' => 'articleNumber',
        'manufacturerNumber' => 'manufacturerNumber',
        'hostId' => 'hostId',
        'purchasePrice' => 'purchasePrice',
        'sellingPrice' => 'sellingPrice',
        'ownageType' => 'ownageType',
        'storageId' => 'storageId',
        'teamviewerId' => 'teamviewerId',
        'teamviewerPassword' => 'teamviewerPassword',
        'anydeskId' => 'anydeskId',
        'anydeskPassword' => 'anydeskPassword',
        'reservedRam' => 'reservedRam',
        'reservedHardDisk' => 'reservedHardDisk',
        'reservedCpu' => 'reservedCpu',
        'description' => 'description'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'inventoryNumber' => 'setInventoryNumber',
        'active' => 'setActive',
        'companyId' => 'setCompanyId',
        'name' => 'setName',
        'serviceTechnicianId' => 'setServiceTechnicianId',
        'employeeId' => 'setEmployeeId',
        'date' => 'setDate',
        'location' => 'setLocation',
        'manufacturerId' => 'setManufacturerId',
        'model' => 'setModel',
        'serialNumber' => 'setSerialNumber',
        'osId' => 'setOsId',
        'software' => 'setSoftware',
        'remark' => 'setRemark',
        'showRemark' => 'setShowRemark',
        'mainboardManufacturerId' => 'setMainboardManufacturerId',
        'mainboardManufacturerRevision' => 'setMainboardManufacturerRevision',
        'mainboardSerialNumber' => 'setMainboardSerialNumber',
        'bios' => 'setBios',
        'biosRelease' => 'setBiosRelease',
        'cpuManufacturerId' => 'setCpuManufacturerId',
        'cpuTypeId' => 'setCpuTypeId',
        'cpuFrequency' => 'setCpuFrequency',
        'cpuNumber' => 'setCpuNumber',
        'mouseSerialNumber' => 'setMouseSerialNumber',
        'keyboadSerialNumber' => 'setKeyboadSerialNumber',
        'server' => 'setServer',
        'internalRemark' => 'setInternalRemark',
        'billingNumber' => 'setBillingNumber',
        'articleNumber' => 'setArticleNumber',
        'manufacturerNumber' => 'setManufacturerNumber',
        'hostId' => 'setHostId',
        'purchasePrice' => 'setPurchasePrice',
        'sellingPrice' => 'setSellingPrice',
        'ownageType' => 'setOwnageType',
        'storageId' => 'setStorageId',
        'teamviewerId' => 'setTeamviewerId',
        'teamviewerPassword' => 'setTeamviewerPassword',
        'anydeskId' => 'setAnydeskId',
        'anydeskPassword' => 'setAnydeskPassword',
        'reservedRam' => 'setReservedRam',
        'reservedHardDisk' => 'setReservedHardDisk',
        'reservedCpu' => 'setReservedCpu',
        'description' => 'setDescription'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'inventoryNumber' => 'getInventoryNumber',
        'active' => 'getActive',
        'companyId' => 'getCompanyId',
        'name' => 'getName',
        'serviceTechnicianId' => 'getServiceTechnicianId',
        'employeeId' => 'getEmployeeId',
        'date' => 'getDate',
        'location' => 'getLocation',
        'manufacturerId' => 'getManufacturerId',
        'model' => 'getModel',
        'serialNumber' => 'getSerialNumber',
        'osId' => 'getOsId',
        'software' => 'getSoftware',
        'remark' => 'getRemark',
        'showRemark' => 'getShowRemark',
        'mainboardManufacturerId' => 'getMainboardManufacturerId',
        'mainboardManufacturerRevision' => 'getMainboardManufacturerRevision',
        'mainboardSerialNumber' => 'getMainboardSerialNumber',
        'bios' => 'getBios',
        'biosRelease' => 'getBiosRelease',
        'cpuManufacturerId' => 'getCpuManufacturerId',
        'cpuTypeId' => 'getCpuTypeId',
        'cpuFrequency' => 'getCpuFrequency',
        'cpuNumber' => 'getCpuNumber',
        'mouseSerialNumber' => 'getMouseSerialNumber',
        'keyboadSerialNumber' => 'getKeyboadSerialNumber',
        'server' => 'getServer',
        'internalRemark' => 'getInternalRemark',
        'billingNumber' => 'getBillingNumber',
        'articleNumber' => 'getArticleNumber',
        'manufacturerNumber' => 'getManufacturerNumber',
        'hostId' => 'getHostId',
        'purchasePrice' => 'getPurchasePrice',
        'sellingPrice' => 'getSellingPrice',
        'ownageType' => 'getOwnageType',
        'storageId' => 'getStorageId',
        'teamviewerId' => 'getTeamviewerId',
        'teamviewerPassword' => 'getTeamviewerPassword',
        'anydeskId' => 'getAnydeskId',
        'anydeskPassword' => 'getAnydeskPassword',
        'reservedRam' => 'getReservedRam',
        'reservedHardDisk' => 'getReservedHardDisk',
        'reservedCpu' => 'getReservedCpu',
        'description' => 'getDescription'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const OWNAGE_TYPE_OWN = 'OWN';
    public const OWNAGE_TYPE_FOREIGN = 'FOREIGN';
    public const OWNAGE_TYPE_OWN_RENT = 'OWN_RENT';
    public const OWNAGE_TYPE_FOREIGN_RENT = 'FOREIGN_RENT';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getOwnageTypeAllowableValues()
    {
        return [
            self::OWNAGE_TYPE_OWN,
            self::OWNAGE_TYPE_FOREIGN,
            self::OWNAGE_TYPE_OWN_RENT,
            self::OWNAGE_TYPE_FOREIGN_RENT,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['inventoryNumber'] = $data['inventoryNumber'] ?? null;
        $this->container['active'] = $data['active'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['name'] = $data['name'] ?? null;
        $this->container['serviceTechnicianId'] = $data['serviceTechnicianId'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['location'] = $data['location'] ?? null;
        $this->container['manufacturerId'] = $data['manufacturerId'] ?? null;
        $this->container['model'] = $data['model'] ?? null;
        $this->container['serialNumber'] = $data['serialNumber'] ?? null;
        $this->container['osId'] = $data['osId'] ?? null;
        $this->container['software'] = $data['software'] ?? null;
        $this->container['remark'] = $data['remark'] ?? null;
        $this->container['showRemark'] = $data['showRemark'] ?? null;
        $this->container['mainboardManufacturerId'] = $data['mainboardManufacturerId'] ?? null;
        $this->container['mainboardManufacturerRevision'] = $data['mainboardManufacturerRevision'] ?? null;
        $this->container['mainboardSerialNumber'] = $data['mainboardSerialNumber'] ?? null;
        $this->container['bios'] = $data['bios'] ?? null;
        $this->container['biosRelease'] = $data['biosRelease'] ?? null;
        $this->container['cpuManufacturerId'] = $data['cpuManufacturerId'] ?? null;
        $this->container['cpuTypeId'] = $data['cpuTypeId'] ?? null;
        $this->container['cpuFrequency'] = $data['cpuFrequency'] ?? null;
        $this->container['cpuNumber'] = $data['cpuNumber'] ?? null;
        $this->container['mouseSerialNumber'] = $data['mouseSerialNumber'] ?? null;
        $this->container['keyboadSerialNumber'] = $data['keyboadSerialNumber'] ?? null;
        $this->container['server'] = $data['server'] ?? null;
        $this->container['internalRemark'] = $data['internalRemark'] ?? null;
        $this->container['billingNumber'] = $data['billingNumber'] ?? null;
        $this->container['articleNumber'] = $data['articleNumber'] ?? null;
        $this->container['manufacturerNumber'] = $data['manufacturerNumber'] ?? null;
        $this->container['hostId'] = $data['hostId'] ?? null;
        $this->container['purchasePrice'] = $data['purchasePrice'] ?? null;
        $this->container['sellingPrice'] = $data['sellingPrice'] ?? null;
        $this->container['ownageType'] = $data['ownageType'] ?? null;
        $this->container['storageId'] = $data['storageId'] ?? null;
        $this->container['teamviewerId'] = $data['teamviewerId'] ?? null;
        $this->container['teamviewerPassword'] = $data['teamviewerPassword'] ?? null;
        $this->container['anydeskId'] = $data['anydeskId'] ?? null;
        $this->container['anydeskPassword'] = $data['anydeskPassword'] ?? null;
        $this->container['reservedRam'] = $data['reservedRam'] ?? null;
        $this->container['reservedHardDisk'] = $data['reservedHardDisk'] ?? null;
        $this->container['reservedCpu'] = $data['reservedCpu'] ?? null;
        $this->container['description'] = $data['description'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getOwnageTypeAllowableValues();
        if (!is_null($this->container['ownageType']) && !in_array($this->container['ownageType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'ownageType', must be one of '%s'",
                $this->container['ownageType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the pc / server
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets inventoryNumber
     *
     * @return string|null
     */
    public function getInventoryNumber()
    {
        return $this->container['inventoryNumber'];
    }

    /**
     * Sets inventoryNumber
     *
     * @param string|null $inventoryNumber inventory number
     *
     * @return self
     */
    public function setInventoryNumber($inventoryNumber)
    {
        $this->container['inventoryNumber'] = $inventoryNumber;

        return $this;
    }

    /**
     * Gets active
     *
     * @return bool|null
     */
    public function getActive()
    {
        return $this->container['active'];
    }

    /**
     * Sets active
     *
     * @param bool|null $active is this pc active or not ?
     *
     * @return self
     */
    public function setActive($active)
    {
        $this->container['active'] = $active;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId id of the company which this pc is assigned to
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name hostname
     *
     * @return self
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets serviceTechnicianId
     *
     * @return int|null
     */
    public function getServiceTechnicianId()
    {
        return $this->container['serviceTechnicianId'];
    }

    /**
     * Sets serviceTechnicianId
     *
     * @param int|null $serviceTechnicianId id of the responsible service technician
     *
     * @return self
     */
    public function setServiceTechnicianId($serviceTechnicianId)
    {
        $this->container['serviceTechnicianId'] = $serviceTechnicianId;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId id of employee, which this pc is assigned to
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date date when this pc was purchased
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets location
     *
     * @return string|null
     */
    public function getLocation()
    {
        return $this->container['location'];
    }

    /**
     * Sets location
     *
     * @param string|null $location location / room of this pc
     *
     * @return self
     */
    public function setLocation($location)
    {
        $this->container['location'] = $location;

        return $this;
    }

    /**
     * Gets manufacturerId
     *
     * @return int|null
     */
    public function getManufacturerId()
    {
        return $this->container['manufacturerId'];
    }

    /**
     * Sets manufacturerId
     *
     * @param int|null $manufacturerId id of the manufacturer of this pc
     *
     * @return self
     */
    public function setManufacturerId($manufacturerId)
    {
        $this->container['manufacturerId'] = $manufacturerId;

        return $this;
    }

    /**
     * Gets model
     *
     * @return string|null
     */
    public function getModel()
    {
        return $this->container['model'];
    }

    /**
     * Sets model
     *
     * @param string|null $model describes the \"model\" of the pc. This field often is used to describe the pc (mostly in lists)
     *
     * @return self
     */
    public function setModel($model)
    {
        $this->container['model'] = $model;

        return $this;
    }

    /**
     * Gets serialNumber
     *
     * @return string|null
     */
    public function getSerialNumber()
    {
        return $this->container['serialNumber'];
    }

    /**
     * Sets serialNumber
     *
     * @param string|null $serialNumber serial number
     *
     * @return self
     */
    public function setSerialNumber($serialNumber)
    {
        $this->container['serialNumber'] = $serialNumber;

        return $this;
    }

    /**
     * Gets osId
     *
     * @return int|null
     */
    public function getOsId()
    {
        return $this->container['osId'];
    }

    /**
     * Sets osId
     *
     * @param int|null $osId id of the operating system
     *
     * @return self
     */
    public function setOsId($osId)
    {
        $this->container['osId'] = $osId;

        return $this;
    }

    /**
     * Gets software
     *
     * @return string|null
     */
    public function getSoftware()
    {
        return $this->container['software'];
    }

    /**
     * Sets software
     *
     * @param string|null $software a text field which contains infos about installed software
     *
     * @return self
     */
    public function setSoftware($software)
    {
        $this->container['software'] = $software;

        return $this;
    }

    /**
     * Gets remark
     *
     * @return string|null
     */
    public function getRemark()
    {
        return $this->container['remark'];
    }

    /**
     * Sets remark
     *
     * @param string|null $remark a text field which contains misc. infos / remarks about this pc
     *
     * @return self
     */
    public function setRemark($remark)
    {
        $this->container['remark'] = $remark;

        return $this;
    }

    /**
     * Gets showRemark
     *
     * @return bool|null
     */
    public function getShowRemark()
    {
        return $this->container['showRemark'];
    }

    /**
     * Sets showRemark
     *
     * @param bool|null $showRemark if true, the remark will be shown as popup when this pc is selected in a support/ticket mask and the employee has the permission
     *
     * @return self
     */
    public function setShowRemark($showRemark)
    {
        $this->container['showRemark'] = $showRemark;

        return $this;
    }

    /**
     * Gets mainboardManufacturerId
     *
     * @return int|null
     */
    public function getMainboardManufacturerId()
    {
        return $this->container['mainboardManufacturerId'];
    }

    /**
     * Sets mainboardManufacturerId
     *
     * @param int|null $mainboardManufacturerId id of the mainboard manufacturer
     *
     * @return self
     */
    public function setMainboardManufacturerId($mainboardManufacturerId)
    {
        $this->container['mainboardManufacturerId'] = $mainboardManufacturerId;

        return $this;
    }

    /**
     * Gets mainboardManufacturerRevision
     *
     * @return string|null
     */
    public function getMainboardManufacturerRevision()
    {
        return $this->container['mainboardManufacturerRevision'];
    }

    /**
     * Sets mainboardManufacturerRevision
     *
     * @param string|null $mainboardManufacturerRevision revision of the mainboard
     *
     * @return self
     */
    public function setMainboardManufacturerRevision($mainboardManufacturerRevision)
    {
        $this->container['mainboardManufacturerRevision'] = $mainboardManufacturerRevision;

        return $this;
    }

    /**
     * Gets mainboardSerialNumber
     *
     * @return string|null
     */
    public function getMainboardSerialNumber()
    {
        return $this->container['mainboardSerialNumber'];
    }

    /**
     * Sets mainboardSerialNumber
     *
     * @param string|null $mainboardSerialNumber serial number of the mainboard
     *
     * @return self
     */
    public function setMainboardSerialNumber($mainboardSerialNumber)
    {
        $this->container['mainboardSerialNumber'] = $mainboardSerialNumber;

        return $this;
    }

    /**
     * Gets bios
     *
     * @return string|null
     */
    public function getBios()
    {
        return $this->container['bios'];
    }

    /**
     * Sets bios
     *
     * @param string|null $bios infos about the bios
     *
     * @return self
     */
    public function setBios($bios)
    {
        $this->container['bios'] = $bios;

        return $this;
    }

    /**
     * Gets biosRelease
     *
     * @return string|null
     */
    public function getBiosRelease()
    {
        return $this->container['biosRelease'];
    }

    /**
     * Sets biosRelease
     *
     * @param string|null $biosRelease release infos of the bios
     *
     * @return self
     */
    public function setBiosRelease($biosRelease)
    {
        $this->container['biosRelease'] = $biosRelease;

        return $this;
    }

    /**
     * Gets cpuManufacturerId
     *
     * @return int|null
     */
    public function getCpuManufacturerId()
    {
        return $this->container['cpuManufacturerId'];
    }

    /**
     * Sets cpuManufacturerId
     *
     * @param int|null $cpuManufacturerId id of the cpu manufacturer
     *
     * @return self
     */
    public function setCpuManufacturerId($cpuManufacturerId)
    {
        $this->container['cpuManufacturerId'] = $cpuManufacturerId;

        return $this;
    }

    /**
     * Gets cpuTypeId
     *
     * @return int|null
     */
    public function getCpuTypeId()
    {
        return $this->container['cpuTypeId'];
    }

    /**
     * Sets cpuTypeId
     *
     * @param int|null $cpuTypeId id of the cpu type
     *
     * @return self
     */
    public function setCpuTypeId($cpuTypeId)
    {
        $this->container['cpuTypeId'] = $cpuTypeId;

        return $this;
    }

    /**
     * Gets cpuFrequency
     *
     * @return int|null
     */
    public function getCpuFrequency()
    {
        return $this->container['cpuFrequency'];
    }

    /**
     * Sets cpuFrequency
     *
     * @param int|null $cpuFrequency frequency of the cpu (in MHz)
     *
     * @return self
     */
    public function setCpuFrequency($cpuFrequency)
    {
        $this->container['cpuFrequency'] = $cpuFrequency;

        return $this;
    }

    /**
     * Gets cpuNumber
     *
     * @return int|null
     */
    public function getCpuNumber()
    {
        return $this->container['cpuNumber'];
    }

    /**
     * Sets cpuNumber
     *
     * @param int|null $cpuNumber number of cpus
     *
     * @return self
     */
    public function setCpuNumber($cpuNumber)
    {
        $this->container['cpuNumber'] = $cpuNumber;

        return $this;
    }

    /**
     * Gets mouseSerialNumber
     *
     * @return string|null
     */
    public function getMouseSerialNumber()
    {
        return $this->container['mouseSerialNumber'];
    }

    /**
     * Sets mouseSerialNumber
     *
     * @param string|null $mouseSerialNumber serial number of the mouse
     *
     * @return self
     */
    public function setMouseSerialNumber($mouseSerialNumber)
    {
        $this->container['mouseSerialNumber'] = $mouseSerialNumber;

        return $this;
    }

    /**
     * Gets keyboadSerialNumber
     *
     * @return string|null
     */
    public function getKeyboadSerialNumber()
    {
        return $this->container['keyboadSerialNumber'];
    }

    /**
     * Sets keyboadSerialNumber
     *
     * @param string|null $keyboadSerialNumber serial number of the keyboard
     *
     * @return self
     */
    public function setKeyboadSerialNumber($keyboadSerialNumber)
    {
        $this->container['keyboadSerialNumber'] = $keyboadSerialNumber;

        return $this;
    }

    /**
     * Gets server
     *
     * @return bool|null
     */
    public function getServer()
    {
        return $this->container['server'];
    }

    /**
     * Sets server
     *
     * @param bool|null $server true if this pc is a server
     *
     * @return self
     */
    public function setServer($server)
    {
        $this->container['server'] = $server;

        return $this;
    }

    /**
     * Gets internalRemark
     *
     * @return string|null
     */
    public function getInternalRemark()
    {
        return $this->container['internalRemark'];
    }

    /**
     * Sets internalRemark
     *
     * @param string|null $internalRemark internal remarks of the pc (can contain passwords), which only is seen by technicians or freelancers with the given permission
     *
     * @return self
     */
    public function setInternalRemark($internalRemark)
    {
        $this->container['internalRemark'] = $internalRemark;

        return $this;
    }

    /**
     * Gets billingNumber
     *
     * @return string|null
     */
    public function getBillingNumber()
    {
        return $this->container['billingNumber'];
    }

    /**
     * Sets billingNumber
     *
     * @param string|null $billingNumber infos about the billing number which this pc was purchased
     *
     * @return self
     */
    public function setBillingNumber($billingNumber)
    {
        $this->container['billingNumber'] = $billingNumber;

        return $this;
    }

    /**
     * Gets articleNumber
     *
     * @return string|null
     */
    public function getArticleNumber()
    {
        return $this->container['articleNumber'];
    }

    /**
     * Sets articleNumber
     *
     * @param string|null $articleNumber article number of the pc
     *
     * @return self
     */
    public function setArticleNumber($articleNumber)
    {
        $this->container['articleNumber'] = $articleNumber;

        return $this;
    }

    /**
     * Gets manufacturerNumber
     *
     * @return string|null
     */
    public function getManufacturerNumber()
    {
        return $this->container['manufacturerNumber'];
    }

    /**
     * Sets manufacturerNumber
     *
     * @param string|null $manufacturerNumber manufacturer number of this pc
     *
     * @return self
     */
    public function setManufacturerNumber($manufacturerNumber)
    {
        $this->container['manufacturerNumber'] = $manufacturerNumber;

        return $this;
    }

    /**
     * Gets hostId
     *
     * @return int|null
     */
    public function getHostId()
    {
        return $this->container['hostId'];
    }

    /**
     * Sets hostId
     *
     * @param int|null $hostId if this pc is a virtual host, then here the id of the host is given
     *
     * @return self
     */
    public function setHostId($hostId)
    {
        $this->container['hostId'] = $hostId;

        return $this;
    }

    /**
     * Gets purchasePrice
     *
     * @return float|null
     */
    public function getPurchasePrice()
    {
        return $this->container['purchasePrice'];
    }

    /**
     * Sets purchasePrice
     *
     * @param float|null $purchasePrice purchase price of this pc
     *
     * @return self
     */
    public function setPurchasePrice($purchasePrice)
    {
        $this->container['purchasePrice'] = $purchasePrice;

        return $this;
    }

    /**
     * Gets sellingPrice
     *
     * @return float|null
     */
    public function getSellingPrice()
    {
        return $this->container['sellingPrice'];
    }

    /**
     * Sets sellingPrice
     *
     * @param float|null $sellingPrice selling price of this pc
     *
     * @return self
     */
    public function setSellingPrice($sellingPrice)
    {
        $this->container['sellingPrice'] = $sellingPrice;

        return $this;
    }

    /**
     * Gets ownageType
     *
     * @return string|null
     */
    public function getOwnageType()
    {
        return $this->container['ownageType'];
    }

    /**
     * Sets ownageType
     *
     * @param string|null $ownageType describes who \"owns\" this pc
     *
     * @return self
     */
    public function setOwnageType($ownageType)
    {
        $allowedValues = $this->getOwnageTypeAllowableValues();
        if (!is_null($ownageType) && !in_array($ownageType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'ownageType', must be one of '%s'",
                    $ownageType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['ownageType'] = $ownageType;

        return $this;
    }

    /**
     * Gets storageId
     *
     * @return int|null
     */
    public function getStorageId()
    {
        return $this->container['storageId'];
    }

    /**
     * Sets storageId
     *
     * @param int|null $storageId id of the storage, the pc is contained in
     *
     * @return self
     */
    public function setStorageId($storageId)
    {
        $this->container['storageId'] = $storageId;

        return $this;
    }

    /**
     * Gets teamviewerId
     *
     * @return string|null
     */
    public function getTeamviewerId()
    {
        return $this->container['teamviewerId'];
    }

    /**
     * Sets teamviewerId
     *
     * @param string|null $teamviewerId TeamViewer id
     *
     * @return self
     */
    public function setTeamviewerId($teamviewerId)
    {
        $this->container['teamviewerId'] = $teamviewerId;

        return $this;
    }

    /**
     * Gets teamviewerPassword
     *
     * @return string|null
     */
    public function getTeamviewerPassword()
    {
        return $this->container['teamviewerPassword'];
    }

    /**
     * Sets teamviewerPassword
     *
     * @param string|null $teamviewerPassword TeamViewer password
     *
     * @return self
     */
    public function setTeamviewerPassword($teamviewerPassword)
    {
        $this->container['teamviewerPassword'] = $teamviewerPassword;

        return $this;
    }

    /**
     * Gets anydeskId
     *
     * @return string|null
     */
    public function getAnydeskId()
    {
        return $this->container['anydeskId'];
    }

    /**
     * Sets anydeskId
     *
     * @param string|null $anydeskId AnyDesk id
     *
     * @return self
     */
    public function setAnydeskId($anydeskId)
    {
        $this->container['anydeskId'] = $anydeskId;

        return $this;
    }

    /**
     * Gets anydeskPassword
     *
     * @return string|null
     */
    public function getAnydeskPassword()
    {
        return $this->container['anydeskPassword'];
    }

    /**
     * Sets anydeskPassword
     *
     * @param string|null $anydeskPassword AnyDesk password
     *
     * @return self
     */
    public function setAnydeskPassword($anydeskPassword)
    {
        $this->container['anydeskPassword'] = $anydeskPassword;

        return $this;
    }

    /**
     * Gets reservedRam
     *
     * @return float|null
     */
    public function getReservedRam()
    {
        return $this->container['reservedRam'];
    }

    /**
     * Sets reservedRam
     *
     * @param float|null $reservedRam reserved ram for this virtual host
     *
     * @return self
     */
    public function setReservedRam($reservedRam)
    {
        $this->container['reservedRam'] = $reservedRam;

        return $this;
    }

    /**
     * Gets reservedHardDisk
     *
     * @return float|null
     */
    public function getReservedHardDisk()
    {
        return $this->container['reservedHardDisk'];
    }

    /**
     * Sets reservedHardDisk
     *
     * @param float|null $reservedHardDisk reserved hard disk space reserved for this virtual host
     *
     * @return self
     */
    public function setReservedHardDisk($reservedHardDisk)
    {
        $this->container['reservedHardDisk'] = $reservedHardDisk;

        return $this;
    }

    /**
     * Gets reservedCpu
     *
     * @return float|null
     */
    public function getReservedCpu()
    {
        return $this->container['reservedCpu'];
    }

    /**
     * Sets reservedCpu
     *
     * @param float|null $reservedCpu reserved cpu capacity reserved for this virtual host
     *
     * @return self
     */
    public function setReservedCpu($reservedCpu)
    {
        $this->container['reservedCpu'] = $reservedCpu;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description misc. description infos for this pc
     *
     * @return self
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


